## ocaml-atd 2.16.0

=== Makefile ===
#
# Makefile for developer's convenience.
# Build logic is implemented with dune.
#

DUNE ?= dune

# Build everything. Should only require OCaml libraries and tools installable
# via opam.
.PHONY: all
all:
	$(MAKE) -C atdpy clean-for-dune
	$(MAKE) -C atdd clean-for-dune
	$(MAKE) -C atdcpp clean-for-dune
	$(MAKE) -C atdts clean-for-dune
	$(DUNE) build

# Install the OCaml dependencies for the build.
.PHONY: setup
setup:
	opam update
	./scripts/install-opam-dependencies

# Build and test everything in a Docker container, producing an
# image named 'atd'.
# This is split into two steps because installing the dependencies takes
# forever each time.
.PHONY: docker
docker:
	$(MAKE) docker-deps
	$(MAKE) docker-build

# This takes a while and has nothing to do with atd.
.PHONY: docker-deps
docker-deps:
	docker build -t atd-deps -f dockerfiles/atd-deps.dockerfile .

.PHONY: docker-build
docker-build:
	docker build -t atd -f dockerfiles/atd.dockerfile .

############################# Testing #####################################

# Test everything. Requires external non-OCaml compilers and libraries
# to support all the target languages.
.PHONY: test
test:
	$(MAKE) test-ocaml
	$(MAKE) test-scala
	$(MAKE) test-java
	$(MAKE) test-python
	$(MAKE) test-ts
	$(MAKE) test-d
	$(MAKE) test-cpp


# Test the OCaml code used by all the backends
test-common:
	$(MAKE) -C atd test
	$(MAKE) -C atdcat test
	$(MAKE) -C atddiff test

# Test only the OCaml backends
.PHONY: test-ocaml
test-ocaml:
	$(MAKE) test-common
	$(MAKE) -C atdgen-runtime test
	$(MAKE) -C atdgen test

# Test only the Scala backend
.PHONY: test-scala
test-scala:
	$(MAKE) test-common
	$(MAKE) -C atds test

# Test only the Java backend
.PHONY: test-java
test-java:
	$(MAKE) test-common
	$(MAKE) -C atdj test

# Test only the Python backend
.PHONY: test-python
test-python:
	$(MAKE) test-common
	$(MAKE) -C atdpy test

# Test only the TypeScript backend
.PHONY: test-ts
test-ts:
	$(MAKE) test-common
	$(MAKE) -C atdts test

.PHONY: test-d
test-d:
	$(MAKE) test-common
	$(MAKE) -C atdd test

.PHONY: test-cpp
test-cpp:
	$(MAKE) test-common
	$(MAKE) -C atdcpp test

############################################################################

.PHONY: js
js:
	$(DUNE) build atdgen/bin/ag_main.bc.js

.PHONY: clean
clean:
	$(DUNE) clean
	$(MAKE) -C atdpy clean
	rm -rf tmp

.PHONY: all-supported-ocaml-versions
all-supported-ocaml-versions:
	$(DUNE) runtest --workspace dune-workspace.dev

.PHONY: doc
doc:
	cd doc && sphinx-build . _build

# Run documentation server.
# See setup instructions in CONTRIBUTING.md
.PHONY: livedoc
livedoc:
	$(MAKE) doc
	python3 -m http.server 8888 --directory doc/_build

# Prepare the opam files for a release. They're derived from 'dune-project'
# and from the template specified in the root 'dune' file..
#
.PHONY: opam-files
opam-files:
	$(DUNE) build *.opam

# This is only part of the release process.
# See complete release instructions in CONTRIBUTING.md.
#
.PHONY: opam-release
opam-release:
	dune-release tag
	dune-release distrib
	dune-release publish
	dune-release opam pkg
	dune-release opam submit

=== atdcat/Makefile ===
DUNE ?= dune

.PHONY: build
build:
	$(DUNE) build

.PHONY: test
test:
	$(DUNE) runtest -f

# Show the expected JSON Schema in YAML format (for visual inspection)
.PHONY: yaml
yaml:
	yq e -P test/schema.expected.json

=== atdcpp/Makefile ===
#
# Dlang/JSON backend
#

DUNE ?= dune

.PHONY: build
build:
	rm -f bin/atdcpp
	$(MAKE) clean-for-dune
	$(DUNE) build @all
	mkdir -p bin
	ln -s ../../_build/install/default/bin/atdcpp bin/atdcpp

# The symlink facilitates the development of test code that depends on the
# generated code.
.PHONY: test
test:
	$(MAKE) clean-for-dune
	$(DUNE) runtest -f; status=$$?; \
	  ln -s ../../../_build/default/atdcpp/test/cpp-tests/everything_atd.hpp \
	    test/cpp-tests/everything_atd.hpp && \
	  ln -s ../../../_build/default/atdcpp/test/cpp-tests/everything_atd.cpp \
	    test/cpp-tests/everything_atd.cpp && \
	  exit "$$status"

.PHONY: clean-for-dune
clean-for-dune:
	rm -f test/cpp-tests/everything_atd.hpp
	rm -f test/cpp-tests/everything_atd.cpp

.PHONY: clean
clean:
	$(MAKE) clean-for-dune
	$(DUNE) clean
	rm -rf bin

=== atddiff/Makefile ===
#
# Compare two versions of the same ATD file.
#

DUNE ?= dune

.PHONY: build
build:
	rm -f bin
	$(DUNE) build
	ln -s ../_build/install/default/bin .

.PHONY: test
test:
	$(MAKE) -C test

# Update the output format of atddiff by running 'make types'.
# This requires an external installation of the atdgen command.
.PHONY: types
types:
	$(MAKE) -C src/lib types

=== atds/Makefile ===
#
# Scala/JSON backend
#

DUNE ?= dune

.PHONY: build
build:
	$(DUNE) build @all

.PHONY: test
test:
	$(DUNE) runtest -f

=== doc/requirements.txt ===
# We use cloud_sptheme because it allows advanced tables
sphinx
sphinx_rtd_theme

=== doc/atdgen-tutorial-data/Makefile ===
.PHONY: clean
clean:
	rm -f */*~
	rm -f */*.cm[ioxa] */*.cmx[as] */*.[oa] */*_[tjv].mli */*_[tjv].ml

=== atddiff/src/lib/Makefile ===
#
# Generate a .ml file containing just the type definitions derived from
# an ATD file.
#
# We don't generate code that exercises the atdgen runtime library
# due to circular dependencies but atddiff users can.
#

# This requires an external installation of the atdgen command.
.PHONY: types
types: Atddiff_output_t.ml

Atddiff_output_t.ml: Atddiff_output.atd
	atdgen -t Atddiff_output.atd

=== atdts/test/ts-tests/Makefile ===
JS ?= node

.PHONY: test
test:
	# Install TypeScript and JavaScript dependencies locally
	npm install
	$(MAKE) lint
	# Compile TypeScript (handwritten + generated by atdts) to JavaScript
	npm run tsc
	# Run the resulting code (compiled from TypeScript)
	$(JS) manual_sample.js
	$(JS) test_atdts.js

# Check for warnings from tslint and eslint, especially in the generated code
.PHONY: lint
lint:
	npm run lint

.PHONY: clean
clean:
	git clean -dfX

=== debian/changelog ===
ocaml-atd (2.16.0-3build1) resolute; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 20 Oct 2025 14:47:57 +0200

ocaml-atd (2.16.0-3) unstable; urgency=medium

  * Add missing build-dependency on libcmdliner-ocaml-dev
    (Closes: #1116827)
  * Bump Standards-Version to 4.7.2
  * Bump debian/watch version to 5

 -- Stéphane Glondu <glondu@debian.org>  Sat, 04 Oct 2025 09:15:29 +0200

ocaml-atd (2.16.0-2) unstable; urgency=medium

  * Use atdgen-runtime in example script

 -- Stéphane Glondu <glondu@debian.org>  Thu, 13 Feb 2025 14:29:32 +0100

ocaml-atd (2.16.0-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Wed, 12 Feb 2025 12:48:55 +0100

ocaml-atd (2.15.0-2) unstable; urgency=medium

  * Fix autopkgtest on bytecode architectures

 -- Stéphane Glondu <glondu@debian.org>  Mon, 12 Aug 2024 19:51:44 +0200

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk
include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with ocaml --buildsystem ocaml_dune

execute_after_dh_auto_build:
	dune exec -p $(shell xargs echo < debian/debian-dune | tr ' ' ',') -- $(MAKE) -C manual

=== debian/watch ===
Version: 5

Source: https://api.github.com/repos/ahrefs/atd/releases?per_page=50
Matching-Pattern: https://[^ "]+/atd-@ANY_VERSION@\.tbz
Searchmode: plain

## ocaml-atd 3.0.1

=== atdts/Makefile ===
#
# TypeScript/JSON backend
#

DUNE ?= dune

.PHONY: build
build:
	rm -f bin/atdts
	$(MAKE) clean-for-dune
	$(DUNE) build @all
	mkdir -p bin
	ln -s ../../_build/install/default/bin/atdts bin/atdts

# The symlink facilitates the development of test code that depends on the
# generated code.
.PHONY: test
test:
	# Run atdts to convert ATD -> TypeScript
	$(DUNE) runtest -f; status=$$?; \
          if [ "$$status" != 0 ]; then \
            echo "Run 'dune promote' to accept diffs, if any."; \
          fi; \
	  exit "$$status"
	# Compile and run the TypeScript code
	$(MAKE) -C test/ts-tests

.PHONY: clean-for-dune
clean-for-dune:


.PHONY: clean
clean:
	$(MAKE) clean-for-dune
	$(DUNE) clean
	rm -rf bin

=== atdts/test/ts-tests/Makefile ===
JS ?= node

.PHONY: test
test:
	# To get the latest generated *.ts files
	dune build
	# Install TypeScript and JavaScript dependencies locally
	npm install
	$(MAKE) lint
	# Compile TypeScript (handwritten + generated by atdts) to JavaScript
	npm run tsc
	# Run the resulting code (compiled from TypeScript)
	#
	# The empty comments are used to force Make to call the shell without
	# which it tries to execute the command directly and fails in some
	# setups (nvm, Node v24.1.0, Ubuntu 24.04, GNU Make 4.3)
	# with "Permission denied" for an unknown reason.
	$(JS) manual_sample.js   #
	$(JS) test_atdts.js      #

# Check for warnings from tslint and eslint, especially in the generated code
.PHONY: lint
lint:
	npm run lint

.PHONY: clean
clean:
	dune clean
	git clean -dfX

=== debian/changelog ===
ocaml-atd (3.0.1-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Mon, 05 Jan 2026 11:00:22 +0100

=== debian/control ===
Source: ocaml-atd
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Stéphane Glondu <glondu@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 ocaml,
 ocaml-dune,
 menhir,
 libcmdliner-ocaml-dev,
 yojson-tools <!nocheck>,
 libalcotest-ocaml-dev <!nocheck>,
 libcamlp-streams-ocaml-dev,
 libeasy-format-ocaml-dev,
 libre-ocaml-dev,
 libbiniou-ocaml-dev,
 libyojson-ocaml-dev (>= 3.0.0),
 python3-jsonschema (>= 4.6.0),
# For the manual:
 libcaml2html-ocaml-dev,
 libfindlib-ocaml-dev,
 hevea,
 camlmix,
 texlive-latex-extra,
# For all OCaml packages:
 dh-ocaml (>= 1.2.2)
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://github.com/ahrefs/atd
Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-atd.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-atd

Package: libatd-ocaml-dev
Architecture: any
Depends: ${ocaml:Depends}, ${misc:Depends}, ${shlibs:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: syntax for cross-language data types in OCaml - development files
 ATD stands for Adjustable Type Definitions. It is a type definition
 language designed to accommodate a variety of programming languages and
 data formats by the means of target-specific annotations. It supports
 sum types, parametrized types and inheritance. The library provides a
 parser and other tools useful for manipulating ATD type definitions.
 .
 This package contains the development files needed for programming
 with the library.

Package: libatd-ocaml
Architecture: any
Depends: ${ocaml:Depends}, ${misc:Depends}, ${shlibs:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: syntax for cross-language data types in OCaml - plugins
 ATD stands for Adjustable Type Definitions. It is a type definition
 language designed to accommodate a variety of programming languages and
 data formats by the means of target-specific annotations. It supports
 sum types, parametrized types and inheritance. The library provides a
 parser and other tools useful for manipulating ATD type definitions.
 .
 This package contains the shared runtime libraries and plugins.

Package: libatdgen-ocaml-dev
Architecture: any
Depends: ${ocaml:Depends}, ${misc:Depends}, ${shlibs:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: OCaml code generator for biniou and JSON - executable and dev files
 Atdgen is a command-line program that takes as input type definitions in
 the ATD syntax and produces OCaml code suitable for data serialization
 and deserialization. Two data formats are currently supported, these are
 biniou and JSON.
 .
 This package contains the adtgen executable and the files necessary
 for programming with the library.

Package: libatdgen-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${misc:Depends},
 ${shlibs:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: OCaml code generator for biniou and JSON - plugins
 Atdgen is a command-line program that takes as input type definitions in
 the ATD syntax and produces OCaml code suitable for data serialization
 and deserialization. Two data formats are currently supported, these are
 biniou and JSON.
 .
 This package contains the shared runtime libraries (plugin).

Package: atdts
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: ocaml-findlib
Description: OCaml code generator for TypeScript
 Atdts is a command-line program that takes as input type definitions in
 the ATD syntax and produces TypeScript classes that can read and write
 JHSON data.
